<?php
namespace Incoviba\Repository\Venta;

use PDO;
use DateTimeImmutable;
use Incoviba\Common\Define;
use Incoviba\Common\Ideal;
use Incoviba\Common\Implement;
use Incoviba\Model;
use Incoviba\Repository;
use Incoviba\Service;

class Cuota extends Ideal\Repository
{
    public function __construct(
        Define\Connection $connection,
        protected Pie $pieRepository,
        protected Repository\Banco $bancoRepository,
        protected Service\Venta\Pago $pagoService
    )
    {
        parent::__construct($connection);
        $this->setTable('cuota');
    }

    public function create(?array $data = null): Model\Venta\Cuota
    {
        $map = (new Implement\Repository\MapperParser(['uf', 'numero']))
            ->register('pie', (new Implement\Repository\Mapper())
                ->setFunction(function($data) {
                    return $this->pieRepository->fetchById($data['pie']);
                }))
            ->register('fecha', new Implement\Repository\Mapper\DateTime('fecha'))
            ->register('valor_$', (new Implement\Repository\Mapper())
                ->setProperty('valor')
            )
            ->register('estado', new Implement\Repository\Mapper\Boolean('estado'))
            ->register('banco', (new Implement\Repository\Mapper())
                ->setFunction(function($data) {
                    if ($data['banco'] === null or $data['banco'] === '') {
                        return null;
                    }
                    return $this->bancoRepository->fetchById($data['banco']);
                }))
            ->register('fecha_pago', (new Implement\Repository\Mapper\DateTime('fecha_pago', 'fechaPago'))
                ->setDefault(null))
            ->register('abonado', (new Implement\Repository\Mapper\Boolean('abonado'))
                ->setDefault(null))
            ->register('fecha_abonado', (new Implement\Repository\Mapper\DateTime('fecha_abonado', 'fechaAbonado'))
                ->setDefault(null))
            ->register('pago', (new Implement\Repository\Mapper())
                ->setFunction(function($data) {
                    if ($data['pago'] === null) {
                        return null;
                    }
                    return $this->pagoService->getById($data['pago']);
                }));
        return $this->parseData(new Model\Venta\Cuota(), $data, $map);
    }

    public function save(Define\Model $model): Model\Venta\Cuota
    {
        $model->id = $this->saveNew(
            ['pie', 'fecha', 'valor_$', 'estado', 'banco', 'fecha_pago', 'abonado', 'fecha_abono', 'uf', 'pago', 'numero'],
            [$model->pie->id, $model->fecha->format('Y-m-d H:i:s'), $model->valor, $model->estado ? 1 : 0, $model->banco?->id,
                null, null, null,
                $model->uf, $model->pago->id, $model->numero]
        );
        return $model;
    }

    public function edit(Define\Model $model, array $new_data): Model\Venta\Cuota
    {
        return $this->update($model, ['pie', 'fecha', 'valor', 'estado', 'banco', 'fecha_pago', 'abonado', 'fecha_abonado', 'uf', 'pago', 'numero'], $new_data);
    }

    public function fetchHoy(): array
    {
        $query = "SELECT a.*
FROM `{$this->getTable()}` a
    JOIN `pago` ON `pago`.`id` = a.`pago`
    JOIN (SELECT e1.* FROM `estado_pago` e1 JOIN (SELECT MAX(`id`) AS `id`, `pago` FROM `estado_pago` GROUP BY `pago`) e0 ON e0.`id` = e1.`id`) ep ON ep.`pago` = `pago`.`id`
    JOIN `tipo_estado_pago` tep ON tep.`id` = ep.`estado`
    JOIN `venta` ON `venta`.`pie` = a.`pie`
    JOIN (SELECT ev1.* FROM `estado_venta` ev1 JOIN (SELECT MAX(`id`) AS 'id', `venta` FROM `estado_venta` GROUP BY `venta`) ev0 ON ev0.`id` = ev1.`id`) ev ON ev.`venta` = `venta`.`id`
    JOIN `tipo_estado_venta` tev ON tev.`id` = ev.`estado`
WHERE tep.`descripcion` = 'no pagado' AND `pago`.`fecha` = CURDATE()
    AND tev.`descripcion` IN ('vigente', 'escriturando', 'firmado por inmobiliaria')";
        return $this->fetchMany($query);
    }
    public function fetchPendientes(): array
    {
        $query = "SELECT a.`id` AS 'cuota_id', `venta`.`id` AS 'venta_id', `proyecto`.`descripcion` AS 'Proyecto', `unidad`.`descripcion` AS 'Departamento',
    `pago`.`valor` AS 'Valor', `pago`.`fecha`, CONCAT_WS(' - ', a.`numero`, `pie`.`cuotas`) AS 'Numero', `banco`.`nombre` AS 'Banco',
    CONCAT_WS(' ', `propietario`.`nombres`, `propietario`.`apellido_paterno`, `propietario`.`apellido_materno`) AS 'Propietario' 
FROM `{$this->getTable()}` a
    JOIN `pago` ON `pago`.`id` = a.`pago`
    JOIN (SELECT e1.* FROM `estado_pago` e1 JOIN (SELECT MAX(`id`) AS 'id', `pago` FROM `estado_pago` GROUP BY `pago`) e0 ON e0.`id` = e1.`id`) ep ON ep.`pago` = `pago`.`id`
    JOIN `tipo_estado_pago` tep ON tep.`id` = ep.`estado`
    JOIN `pie` ON `pie`.`id` = a.`pie`
    JOIN `venta` ON `venta`.`pie` = a.`pie`
    JOIN (SELECT ev1.* FROM `estado_venta` ev1 JOIN (SELECT MAX(`id`) AS 'id', `venta` FROM `estado_venta` GROUP BY `venta`) ev0 ON ev0.`id` = ev1.`id`) ev ON ev.`venta` = `venta`.`id`
    JOIN `tipo_estado_venta` tev ON tev.`id` = ev.`estado`
    JOIN `propietario` ON `propietario`.`rut` = `venta`.`propietario`
    JOIN `propiedad_unidad` pu ON pu.`propiedad` = `venta`.`propiedad`
    JOIN `unidad` ON `unidad`.`id` = pu.`unidad` AND pu.`principal` = 1
    JOIN `proyecto_tipo_unidad` ptu ON ptu.`id` = `unidad`.`pt`
    JOIN `proyecto` ON `proyecto`.`id` = ptu.`proyecto`
    JOIN `banco` ON `banco`.`id` = `pago`.`banco`
WHERE tep.`descripcion` = 'no pagado' AND `pago`.`fecha` < CURDATE()
    AND tev.`descripcion` IN ('vigente', 'escriturando', 'firmado por inmobiliaria')
ORDER BY `pago`.`fecha` DESC";
        return $this->fetchAsArray($query);
    }
    public function fetchDepositadas(): array
    {
        $query = "SELECT a.`id` AS 'cuota_id', `venta`.`id` AS 'venta_id', `proyecto`.`descripcion` AS 'Proyecto', `unidad`.`descripcion` AS 'Departamento',
    `pago`.`valor` AS 'Valor', `pago`.`fecha`, CONCAT_WS(' - ', a.`numero`, `pie`.`cuotas`) AS 'Numero', `banco`.`nombre` AS 'Banco', ep.`fecha` AS 'Fecha Depositada',
    CONCAT_WS(' ', `propietario`.`nombres`, `propietario`.`apellido_paterno`, `propietario`.`apellido_materno`) AS 'Propietario' 
FROM `{$this->getTable()}` a
    JOIN `pago` ON `pago`.`id` = a.`pago`
    JOIN (SELECT e1.* FROM `estado_pago` e1 JOIN (SELECT MAX(`id`) AS 'id', `pago` FROM `estado_pago` GROUP BY `pago`) e0 ON e0.`id` = e1.`id`) ep ON ep.`pago` = `pago`.`id`
    JOIN `tipo_estado_pago` tep ON tep.`id` = ep.`estado`
    JOIN `pie` ON `pie`.`id` = a.`pie`
    JOIN `venta` ON `venta`.`pie` = a.`pie`
    JOIN (SELECT ev1.* FROM `estado_venta` ev1 JOIN (SELECT MAX(`id`) AS 'id', `venta` FROM `estado_venta` GROUP BY `venta`) ev0 ON ev0.`id` = ev1.`id`) ev ON ev.`venta` = `venta`.`id`
    JOIN `tipo_estado_venta` tev ON tev.`id` = ev.`estado`
    JOIN `propietario` ON `propietario`.`rut` = `venta`.`propietario`
    JOIN `propiedad_unidad` pu ON pu.`propiedad` = `venta`.`propiedad`
    JOIN `unidad` ON `unidad`.`id` = pu.`unidad` AND pu.`principal` = 1
    JOIN `proyecto_tipo_unidad` ptu ON ptu.`id` = `unidad`.`pt`
    JOIN `proyecto` ON `proyecto`.`id` = ptu.`proyecto`
    JOIN `banco` ON `banco`.`id` = `pago`.`banco`
WHERE tep.`descripcion` = 'depositado' AND `pago`.`fecha` < CURDATE()
    AND tev.`descripcion` IN ('vigente', 'escriturando', 'firmado por inmobiliaria')
ORDER BY `pago`.`fecha` DESC";
        return $this->fetchAsArray($query);
    }
    public function fetchDatosPorVencer(): array
    {
        $query = "SELECT `pago`.`fecha` AS 'Fecha', `proyecto`.`descripcion` AS 'Proyecto', COUNT(a.`id`) AS 'Cantidad'
FROM `{$this->getTable()}` a
    JOIN `pago` ON `pago`.`id` = a.`pago`
    JOIN (SELECT e1.* FROM `estado_pago` e1 JOIN (SELECT MAX(`id`) AS 'id', `pago` FROM `estado_pago` GROUP BY `pago`) e0 ON e0.`id` = e1.`id`) ep ON ep.`pago` = `pago`.`id`
    JOIN `tipo_estado_pago` tep ON tep.`id` = ep.`estado`
    JOIN `venta` ON `venta`.`pie` = a.`pie`
    JOIN (SELECT ev1.* FROM `estado_venta` ev1 JOIN (SELECT MAX(`id`) AS 'id', `venta` FROM `estado_venta` GROUP BY `venta`) ev0 ON ev0.`id` = ev1.`id`) ev ON ev.`venta` = `venta`.`id`
    JOIN `tipo_estado_venta` tev ON tev.`id` = ev.`estado`
    JOIN `propiedad_unidad` pu ON pu.`propiedad` = `venta`.`propiedad` AND pu.`principal` = 1
    JOIN `unidad` ON `unidad`.`id` = pu.`unidad`
    JOIN `proyecto_tipo_unidad` ptu ON ptu.`id` = `unidad`.`pt`
    JOIN `proyecto` ON `proyecto`.`id` = ptu.`proyecto`
WHERE tep.`descripcion` = 'no pagado' AND `pago`.`fecha` BETWEEN DATE_ADD(CURDATE(), INTERVAL 1 DAY) AND DATE_ADD(CURDATE(), INTERVAL 1 MONTH)
     AND tev.`descripcion` IN ('vigente', 'escriturando', 'firmado por inmobiliaria')
GROUP BY `pago`.`fecha`, `proyecto`.`descripcion`
ORDER BY `pago`.`fecha`, `proyecto`.`descripcion`";
        return $this->fetchAsArray($query);
    }
    public function fetchVigenteByPie(int $pie_id): array
    {
        $query = "SELECT a.*
FROM `{$this->getTable()}` a
    JOIN `pago` ON `pago`.`id` = a.`pago`
    JOIN (SELECT e1.* FROM `estado_pago` e1 JOIN (SELECT MAX(`id`) AS 'id', `pago` FROM `estado_pago` GROUP BY `pago`) e0 ON e0.`id` = e1.`id`) ep ON ep.`pago` = `pago`.`id`
    JOIN `tipo_estado_pago` tep ON tep.`id` = ep.`estado`
WHERE a.`pie` = ? AND tep.`active` = 1";
        return $this->fetchMany($query, [$pie_id]);
    }
}
